#include <pthread.h>
#include <stdio.h>
#include <malloc.h>

typedef struct {

  int sum;

} shareddata;

shareddata sh;
pthread_mutex_t mutx;
pthread_t pchild;


void *Child(void *arg) {

    /* Child process */

  int sum, oldsum;

  printf("Child pid = %d\n", getpid());

  for(;;) {

    sleep(5);
    pthread_mutex_lock(&mutx);
    sum = sh.sum;
    pthread_mutex_unlock(&mutx);

    printf("child. sum = %ld\n", sum);

    if (sum == oldsum) {
      pthread_exit(NULL);
    }

    oldsum = sum;
  }
    //  pthread_exit((void*) 0);
  pthread_exit(NULL);
}


int main() {

  pthread_attr_t attr;
  int i, status;
  

  /*  Pthreads initialisation */

  pthread_mutex_init(&mutx, NULL);

  pthread_attr_init(&attr);
  pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);
  //  pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
  

  if(pthread_create(&pchild, &attr, Child, NULL) != 0) {
    printf("Error creating pthread\n");
    return -1;
  }  

  printf("Parent process pid=%d\n", getpid());

  for(i=0; i<5; i++) {

    //    sleep(5);
    pthread_mutex_lock(&mutx);
    sh.sum = i;
    pthread_mutex_unlock(&mutx);


    printf("Parent. shared.sum = %d\n", i);

  }

  pthread_join(pchild, (void **)&status);

  pthread_attr_destroy(&attr);

  return 0;
}
