/*
 * $Id: text_ops.h,v 1.5 2003/ 12:23:53 jaime Rel $
 *
 * Copyright (C) 2001-2003 Fhg Fokus
 *
 * This file is part of ser, a free SIP server.
 *
 * ser is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * For a license to use the ser software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * ser is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <regex.h>
#include <sys/types.h> /* for regex */
#include <stdlib.h>

#include "../../str.h"
#include "../../data_lump_rpl.h"

#define append_str(_p,_s,_l) \
	{memcpy((_p),(_s),(_l));\
	(_p) += (_l);}

#define IP4_LENGTH 16

int match(const char *string, char *pattern, regmatch_t *pm);
long int string_to_int(char *s);
int int_to_char(char *dest, int src, int size);
int get_offset_end(char *string, char *key);
int get_offset_start(char *string, char *key);
char* skip_chars(char* _s);
char* skip_delims(char* _s);
int get_int_value(char *s, char *key);
char* get_char_value(char *s, char *key);
